package com.vendor.burn.commands;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.vendor.burn.commands.SerialCommand;
import com.vendor.burn.model.config.PreferenceConfig;
import com.vendor.burn.preferences.FastbootPreferences;
import com.vendor.burn.utilitily.ToolUtils;
import org.eclipse.jface.preference.IPreferenceStore;

public class MWCommand extends SerialCommand {
  private static final String KEY_MW = "mw.b";
  
  public static final String HEX_0xFF = "0xFF";
  
  public static final String HEX_0x00 = "0x00";
  
  private MWCommand(String command, String length) {
    setCommand(command);
    init(length);
  }
  
  private void init(String length) {
    setTimeout(calculateTimeOut(length));
  }
  
  public static com.vendor.burn.commands.MWCommand mwAddress(String startAddress, String length) {
    String fillData = null;
    if (ToolUtils.isCmdLine()) {
      fillData = String.valueOf(PreferenceConfig.getImgFillData());
    } else {
      IPreferenceStore preferences = FastbootPreferences.getPreferenceStore();
      fillData = preferences.getString("vendor.burn.config.imageFill");
    } 
    if ("0xFF".equalsIgnoreCase(fillData))
      return mwAddress_0x00(startAddress, length); 
    return mwAddress_0xFF(startAddress, length);
  }
  
  private static com.vendor.burn.commands.MWCommand mwAddress_0xFF(String startAddress, String length) {
    StringBuilder sb = new StringBuilder();
    sb.append("mw.b").append(" ");
    if (!length.startsWith("0x"))
      sb.append("0x"); 
    sb.append(startAddress).append(" ").append("0xFF").append(" ");
    if (!length.startsWith("0x"))
      sb.append("0x"); 
    sb.append(length);
    return new com.vendor.burn.commands.MWCommand(sb.toString(), length);
  }
  
  private static com.vendor.burn.commands.MWCommand mwAddress_0x00(String startAddress, String length) {
    StringBuilder sb = new StringBuilder();
    sb.append("mw.b").append(" ");
    if (!length.startsWith("0x"))
      sb.append("0x"); 
    sb.append(startAddress).append(" ").append("0x00").append(" ");
    if (!length.startsWith("0x"))
      sb.append("0x"); 
    sb.append(length);
    return new com.vendor.burn.commands.MWCommand(sb.toString(), length);
  }
  
  public int calculateTimeOut(String length) {
    int parseLong = Integer.parseInt(length, 16);
    return parseLong / 30;
  }
}
